/**分类书籍的box容器 横大*/

import { Text, View, Image, Navigator } from "@tarojs/components";
import React from 'react'
import './index.less'
export interface BookboxColumnBigProps {
    book_id?: number,//书籍ID
    book_name?: string,//名称
    penname?: string,//作者
    intro?: string,//描述
    cover?: string,//图片
    category?: string,//标签分类
    sign?: string,//热度，阅读人数 
    action?: string//地址
}
function BookboxColumnBig(props: BookboxColumnBigProps) {
    const { cover, book_name, penname, book_id } = props
    return <View className='book_box_column_big'>
        <Navigator url={'/pages/book/bookDetails/index?book_id=' + book_id} hoverClass="none">
            <Image src={cover || ''} className='img'></Image>
            <View className='bottom'>
                <Text className='title'>{book_name}</Text>
                <Text className='author'>{penname}</Text>
            </View>
        </Navigator>
    </View>
}

export default React.memo(BookboxColumnBig)