import React, { useEffect, useState } from 'react';
import { observer, inject } from 'mobx-react';
import { useDidHide, useDidShow } from '@tarojs/taro';
//==========components组件引用========================
import TopNavBar from '@src/components/TopNavBar';
import ScrollViewHoc from '@src/components/ScrollView';
import Empty from '@src/components/Empty';
import { Store } from '@src/app';


interface Props {
    store: Store;
}

const Index: React.FC<Props> = ({ store }) => {
    const [pageShow,setPageShow]=useState(false)//防止小程序切换页面组件不会被真实卸载,阻止不必要的操作
    useEffect(() => {
        log("store.appInfoStore.appInfo", store.appInfoStore.appInfo);
        log("APP", app);
        return () => {
            log("componentWillUnmount");
        };
    }, [store.appInfoStore.appInfo,pageShow]); // Dependency array, runs effect only once on mount and unmount

    // 使用 useDidShow 代替 onShow
    useDidShow(() => {
        setPageShow(true)
        log("Page is shown or brought to foreground");
    });

    // 使用 useDidHide 如果需要在页面隐藏时做一些处理
    useDidHide(() => {
        setPageShow(false)
        log("Page is hidden or sent to background");
    });
    return (
        <ScrollViewHoc>
            <Empty />
        </ScrollViewHoc>
    );
};
export default TopNavBar(inject('store')(observer(Index)), {
    tab: true,
    tabVal: [{ value: "男生", text: "男生" }, { value: "女生", text: "女生" }],
    backgroundColor: '#fff',
    color: "#333",
    search: false
});