import { Component } from 'react'
import Taro from '@tarojs/taro'
import { View, Text, Image, Button, Navigator } from '@tarojs/components'
import { observer, inject } from 'mobx-react'
import './index.less'
// import { pushUserInfo, pushAdLog, getUserInfoSecond, setSign, getVideoNoin, setTaskCoin, addSubscribe } from '../../api'
import { getLoginSto } from '@src/utils/loginSto'

// import TipsUnlocking from '../../components/guidePage/tipsUnlocking'
// import Toast from '../../components/guidePage/toast'
// import SceneTips from '../../components/guidePage/sceneTips'
// import Subscribe from '../../components/guidePage/subscribe'
// import SignTips from '../../components/guidePage/signTips'

type PageStateProps = {
    store: {
        indexStore: {
            navBarTop: number,
            SET_NAVBARMARGINTOP: Function,
            openType: number,
            userInfo: userInfo,
            SET_USERINFO: Function
        }
    }
}
interface My {
    props: PageStateProps;
}

type userInfo = {
    user_name: string,
    avatar_url: string,
    is_auth: number,
    is_vip: boolean,
    member_end_date: string,
}

type state = {
    canIUseGetUserProfile: boolean,
    videoAd: Taro.RewardedVideoAd | undefined,
    isPullVideo: boolean,
    signInfo: {   // 签到信息
        list: any[],
        signInfo: any
    },
    account: number, // 我的免费豆
    task: {          // 任务相关信息
        daily: any,
        important: any
    },
    toastInfo: {
        title: string,
        reward: number,
        show: boolean
    },
    messageShow: boolean,
    signShow: boolean,
    signType: 'direct' | 'look' | 'lookTask'
}

let _this: any = null

@inject('store')
@observer
class My extends Component {

    state: state = {
        canIUseGetUserProfile: false,
        videoAd: undefined,
        isPullVideo: false,
        signInfo: {
            list: [],
            signInfo: {}
        },
        account: 0,
        task: {
            daily: {},
            important: {}
        },
        toastInfo: {
            title: '',
            reward: 0,
            show: false
        },
        messageShow: false,
        signShow: false,
        signType: 'direct'
    }

    componentDidShow() {
        this.getData()
    }

    onLoad() {
        /*   @ts-ignore */
        if (wx.getUserProfile) {
            this.setState({
                canIUseGetUserProfile: true
            })
        }
        Taro.getSystemInfo({
            success(res) {
                log('===========', res);

            }
        })
        _this = this
    }


    getUserProfile() {
        // 推荐使用wx.getUserProfile获取用户信息，开发者每次通过该接口获取用户个人信息均需用户确认
        // 开发者妥善保管用户快速填写的头像昵称，避免重复弹窗
        /*   @ts-ignore */
        wx.getUserProfile({
            desc: '用于完善会员资料', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
            success: res => {
                _this.setState({
                    userInfo: res.userInfo
                })
                // let { city, country, gender, nickName, province, avatarUrl } = res.userInfo
                let { open_id } = getLoginSto()
                // pushUserInfo({ openid: open_id, city, country, gender, nickname: nickName, province, avatarUrl }).then(() => {
                //     _this.getData()
                // })
            }
        })
    }

    getData = (type?: string) => {
        let { indexStore } = this.props.store
        // getUserInfoSecond().then((res: any) => {
        //     this.getInsertScreen()
        //     indexStore.SET_USERINFO()
        //     let body = res?.body
        //     this.setState({
        //         signInfo: body?.sign,
        //         task: body?.task,
        //         account: body?.userinfo?.account
        //     })
        //     let { is_receive, subscribe_coin } = body?.task?.important
        //     if (type && type === 'sub' && is_receive === 1) {
        //         this.setState({
        //             toastInfo: {
        //                 title: '消息订阅',
        //                 reward: subscribe_coin,
        //                 show: true
        //             }
        //         })
        //     }
        // })
    }




    handleWXGetUserInfo = (event) => {
        let detail = event.detail
        // let { city, country, gender, nickName, province, avatarUrl } = detail.userInfo
        this.setState({
            userInfo: detail.userInfo
        })
        let { open_id } = getLoginSto()
        // pushUserInfo({ openid: open_id, city, country, gender, nickname: nickName, province, avatarUrl }).then(() => {
        //     this.getData()
        // })
    }


    render() {
        let { indexStore } = this.props.store

        return (
            <View className='my'>
                <View className="userInfo">
                    <Image src={require('../../icon/myBack.png')} />
                    <View className="userInfo_box">
                        <View className="top" style={indexStore.openType === 1 ? { marginTop: Taro.pxTransform(130) } : {}}>
                            <View className="left">
                                <View className="avtai">
                                    <Image mode="widthFix" lazy-load src={indexStore.userInfo?.avatar_url ? indexStore.userInfo?.avatar_url : require('../../icon/avatar.jpg')} />
                                </View>
                                <View className="name" style={indexStore.userInfo?.is_auth === 0 ? { width: Taro.pxTransform(120) } : {}}>

                                    {
                                        indexStore.openType !== 1 ? <View className="ID">{indexStore.userInfo?.user_name || ""}</View> :
                                            <View className="ID">读友_sdajhsd</View>
                                    }
                                    {
                                        indexStore.userInfo?.is_vip && indexStore.openType !== 1 && <View className="grade">
                                            <Image lazy-load src={require('../../icon/grade.png')} />
                                            <Text>V1</Text>
                                        </View>
                                    }
                                </View>
                            </View>
                            {
                                indexStore.userInfo?.is_auth === 0 && <View className="right">
                                    {
                                        this.state.canIUseGetUserProfile ?
                                            <Button onClick={this.getUserProfile} className="loginBt">
                                                <Image lazy-load src={require('../../icon/loaginBt.png')} />
                                            </Button>
                                            :
                                            <Button openType='getUserInfo' onGetUserInfo={this.handleWXGetUserInfo.bind(this)} className="loginBt">
                                                <Image lazy-load src={require('../../icon/loaginBt.png')} />
                                            </Button>
                                    }
                                </View>
                            }
                        </View>
                        {/* vip续费 */}
                        <View className="bottom">
                            <View>
                                <View className="left">
                                    <Image lazy-load src={require('../../icon/VIP.png')} />
                                    <View className="txt">
                                        <Text>会员尊享免费解锁权益</Text>
                                        {
                                            indexStore.userInfo?.is_vip && <Text className="tfv">有效期至:{indexStore.userInfo?.member_end_date}</Text>
                                        }
                                    </View>
                                </View>
                                <View className="right" onClick={() => { Taro.navigateTo({ url: '/pages/vipCore/index' }) }}>{indexStore.userInfo?.is_vip ? '立即续费' : '立即开通'}</View>
                            </View>
                            <Image lazy-load src={require('../../icon/vipBack.png')} />
                        </View>
                    </View>
                </View>


                {/* 底部功能入口 */}
                <View className="list_bt" style={indexStore.openType === 1 ? { marginTop: Taro.pxTransform(100) } : {}}>
                    <Navigator className="item" url="/pages/contactus/index">
                        <View className="left">
                            <Image lazy-load src={require('../../icon/phone.png')} mode="widthFix" />
                            <Text>联系客服</Text>
                        </View>
                        <View className="right">
                            <Image lazy-load src={require('../../icon/jtRight.png')} mode="widthFix" />
                        </View>
                    </Navigator>
                    <View className="line"></View>
                    <Navigator className="item" url="/pages/aboutWe/index">
                        <View className="left">
                            <Image lazy-load src={require('../../icon/we.png')} mode="widthFix" />
                            <Text>关于我们</Text>
                        </View>
                        <View className="right">
                            <Image lazy-load src={require('../../icon/jtRight.png')} mode="widthFix" />
                        </View>
                    </Navigator>
                </View>
            </View>
        )
    }
}

export default My
